<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 4</H1>

<P>
Numéro du papier: 4

<P>Nom du papier et auteurs: Compilation de la sémantique naturelle vers ML,
<P>    Catherine Dubois, Richard Gayraud

<H2>1</H2>

<P>
Nom du rapporteur: Jean Goubault-Larrecq

<P>Confiance en la note: (de 1 à 3) 3
<P> (1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.)

<P>Notation du papier: (de 1 à 5) 3
<P> (1: à rejeter; 2: inintéressant; 3: acceptable;
<P>  4: bon papier; 5: très bon papier)

<P>Commentaires aux auteurs:
<P>    Cet article est fondé sur de très bonnes idées, et les auteurs
montrent qu'elle a des effets parfois spectaculaires d'accélération
des programmes exécutant les spécifications de sémantique
naturelle par rapport à Prolog.  Malheureusement, l'article est
desservi par une rédaction approximative des définitions et des
algorithmes; c'est particulièrement net à partir de la section 4.3.
Les points les plus saillants sont la définition d'une direction
fortement cohérente dans un contexte en section 4.3.2, et la
description de l'algorithme $\cal A$ en section 4.4, qui est
passablement inscrutable.
<P>    Plus en détail, en section 4.3.2, ``$\overline C$ désigne le
point fixe obtenu à partir de $C$ et [...]'': duquel s'agit-il,
du plus petit, du plus grand, d'un autre ?  De plus, il serait plus
simple de dire qu'il s'agit d'un point fixe de $rem$, plutôt que
de recourir à la formulation vague ci-dessus.  Toujours en
section 4.3.2, pourquoi recourir à $\overline {C + (p,d)}$
plutôt qu'à $\overline C$, tout simplement ? Il faudrait préciser
que le but d'écrire $C + (p,d)$ n'est pas ici d'ajouter une liaison
de $p$ à $d$ dans $C$, mais au contraire de supprimer toutes
les liaisons de $p$ à quoi que ce soit d'autre, pour prendre en
compte la restriction à la cohérence *forte*.  Malheureusement,
la définition d'une direction fortement cohérente pour une relation
$p$ dans $C$ est incorrecte, car il s'agit d'une récurrence qui n'est
pas bien-fondée.  Une définition plus simple serait peut-être :
il existe un contexte simple $C'$ tel que $C' (p') \subseteq C (p')$
pour tout $p$ et $C' (p) = \{d\}$, tel que $d \in \overline {C'}$.
<P>    En 4.4, la définition de $\cal A$ est peu claire.  De plus, la
définition de ${\cal A} (r, C_{hyp})$, au bas de la page 16,
utilise des expressions ambigu\"es: ``$C$ le contexte, réduit aux
relations des prémisses'' (s'agit-il plutôt de la définition
du domaine de $C$ ?), la parenthèse ``calculées par permutation
des prémisses'' (quid ?)
<P>    On trouve aussi d'autres erreurs mineures.  En p.4, l.11,
``section ??''.  En p.11, ``régles''.  En p.12, la formule définissant
$Cl_{p/d}$ pourrait restreindre $f_1$ et $f_2$ par $f_1 < f_2$,
sinon la somme compte tous les produits deux fois.  En p.13,
définition de la complexité totale, ``l'orientation $o_l$ telle que
[...]'' n'est pas unique.
<P>    En p.4, 5ème paragraphe, les auteurs semblent redécouvrir
la notion de point fixe; 6ème paragraphe, de plus petit point fixe.
Il s'agit de notions bien connues en sémantique de langages
de programmation, depuis au moins 35 ans, et qui pourraient donc
être mentionnées.  Les auteurs semblent ensuite croire qu'il
n'y aurait que deux ``intuitions différentes de la cohérence'',
alors qu'il y en a bien s\^ur une infinité en général : il s'agit
ici d'une interprétation abstraite, et qui découle donc de
l'attirail classique de théorèmes et de techniques de
l'interprétation abstraite.  Il est à porter au crédit des auteurs,
cependant, d'avoir vu la parenté de leur problème avec
celui de la détection de modes en Prolog (Debray, mais aussi
Hermenegildo et d'autres ont écrit sur ce sujet).  Bien que
leur problème soit plus compliqué que celui de la détection
de modes---notamment parce que l'espace des solutions
n'est pas un treillis, mais un sup-semi-treillis, et que les
directions minimales (pour $\subseteq$) ne sont pas uniques---,
les auteurs semblent n'avoir accordé que peu d'importance à
l'efficacité de leur algorithme.  Le fait que les ensembles de
directions possibles soient des idéaux (upper-ideals), en particulier,
les autorisait à ne renvoyer que les directions minimales, les
autres s'en déduisant aisément.
<P>    Les auteurs devraient d'autre part justifier mieux l'intérêt
de savoir permuter des prémisses.  Cette caractéristique de
leur problème est l'un des principaux responsables de la complexité
exponentielle de leur algorithme, et l'on peut objecter que nombre
d'utilisateurs écrivent naturellement déjà leurs prémisses dans l'ordre
qui sera trouvé par l'algorithme.  De plus, les auteurs remarquent
eux-mêmes que l'intégration avec des fonctions Caml ayant
un effet de bord pose problème.  Un exemple naturel o\`u le fait
de changer la direction souhaitée pour calculer le résultat final,
par exemple de $\{1,2\}$ en $\{2,3\}$, provoquerait un changement
de l'ordre d'évaluation des prémisses (par exemple, de
gauche-droite en droite-gauche), existe certainement, et étayerait
mieux les motivations des auteurs.
<P>
Commentaires réservés au comité de programme:



<H2>2</H2>

<P>Nom du rapporteur: Pierre Weis

<P>Confiance en la note: 2
<P>  1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.

<P>Notation du papier: 4
<P>  1: a rejeter; 2: ininteressant; 3: acceptable;
<P>  4: bon papier; 5: tres bon papier

<P>Commentaires aux auteurs:

<P>Un bon papier, bien écrit. De bonnes idées pour améliorer l'efficacité
de l'exécution des spécifications en sémantique naturelle. Une bonne
application de la programmation fonctionnelle.

<P>On aurait cependant aimé voir des exemples de résultat de
compilation pour fixer les idées. Ces exemples remplaceraient
avantageusement tout ou partie de la section 3.2.

<P>Dans votre paragraphe 6 vous notez qu'il est facile d'incorporer des
variables logiques dans votre modèle d'exécution. Cependant comment se
comporterait votre formalisme si ces variables étaient introduites
(par exemple par des indications explicites de l'utilisateur comme
vous le suggérez) ? Pourrait-on encore inférer les directions au
moins pour certaines règles ?

<P>Détails:
<P>Page 4: ligne 11 référence erronée.

<P>Commentaires reserves au comite de programme:


</BODY>
</HTML>
